#include <FastLED.h>
#define NUM_LEDS 15
#define DATA_PIN 1

CRGB leds[NUM_LEDS];
int test = 0;

int period = 500;
unsigned long time_now = 0;
byte Position = 0;
byte h = 0;

void setup() {
  // put your setup code here, to run once:
  LEDS.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS);
  pinMode(0, INPUT_PULLUP);

}

void loop() {
  // put your main code here, to run repeatedly:
  if (digitalRead(0) == LOW) {
    if (test < 13) {
      test++;
    } else {
      test = 0;
    }
    delay(250);
  }
  if (test == 0) {
    for (int i = 0; i < NUM_LEDS; i++) {      //Red
      leds[i].setRGB(255, 0, 0);
    }
  } else if (test == 1) {
    for (int i = 0; i < NUM_LEDS; i++) {      //Green
      leds[i].setRGB(0, 255, 0);
    }
  } else if (test == 2) {
    for (int i = 0; i < NUM_LEDS; i++) {      //Blue
      leds[i].setRGB(0, 0, 255);
    }
  } else if (test == 3) {
    for (int i = 0; i < NUM_LEDS; i++) {      //Yellow
      leds[i].setRGB(255, 255, 0);
    }
  } else if (test == 4) {
    for (int i = 0; i < NUM_LEDS; i++) {      //Teal
      leds[i].setRGB(0, 255, 255);
    }
  } else if (test == 5) {
    for (int i = 0; i < NUM_LEDS; i++) {      //Pink
      leds[i].setRGB(255, 0, 255);
    }
  } else if (test == 6) {
    for (int i = 0; i < NUM_LEDS; i++) {      //White
      leds[i].setRGB(255, 255, 255);
    }
  } else if (test == 7) {                   //Slow Rainbow
    uint8_t beatA = beatsin8(7, 0, 255);
    fill_rainbow(leds, NUM_LEDS, beatA, 2);

  }
  else if (test == 8) {                   //Gradual Rainbow
    uint8_t starthue = beatsin8(5, 0, 255);
    uint8_t endhue = beatsin8(7, 0, 255);

    if (starthue < endhue) {
      fill_gradient(leds, NUM_LEDS, CHSV(starthue, 255, 255), CHSV(endhue, 255, 255), FORWARD_HUES); // If we don't have this, the colour fill will flip around.
    } else {
      fill_gradient(leds, NUM_LEDS, CHSV(starthue, 255, 255), CHSV(endhue, 255, 255), BACKWARD_HUES);
    }

  } else if (test == 9) {               //Party
    uint8_t beat = beatsin8( 18, 0, 255);
    for ( byte i = 0; i < NUM_LEDS; i++) {
      leds[i].setHSV(beat, 255, 255);
    }
  }
  else if (test == 10) {    //trailing
    fadeToBlackBy( leds, NUM_LEDS, 4);
    int pos = beatsin16(20, 0, NUM_LEDS - 1);
    leds[pos] += CHSV( 0, 255, 192);
  } else if (test > 10) {
    if (millis() > time_now + period) {
      time_now = millis();
      if (test == 11) {               //shooting star
        fadeToBlackBy( leds, NUM_LEDS, 80);
        period = 100;
        if (Position < NUM_LEDS+1) {
          leds[Position - 1].setHSV(h, 255, 255);
          Position++;
          FastLED.show();
        } else {
          h = random(255);
          Position = 1;
        }
      }
      else if (test == 12) {               //color wipe
        if (Position < NUM_LEDS + 1 && Position != 0) {
          leds[Position - 1].setHSV(h, 255, 255);
          Position++;
          FastLED.show();
        } else {
          h = random(255);
          Position = 1;
        }
      }else if(test == 13){
        period = 4000;            //random flash
        fill_solid(leds, NUM_LEDS, CHSV(random(255), 255, 255));
      }
    }
  }
  FastLED.show();
}
